﻿using System;
using System.Linq;
using IdeaBlade.EntityModel;

using SimpleNorthwindModel;
using IdeaBlade.EntityModel.Security;

namespace Console01 {

  class Program {

    static void Main(string[] args) {
      new Program().DoIt();
    }

    void DoIt() {

      NorthwindManager mgr = new NorthwindManager();
      Console.WriteLine("Thread principal before login: {0}", System.Threading.Thread.CurrentPrincipal.Identity.Name);

      // Login will null credentials.  The LoginManager will decide what to do ...
      Authenticator.Instance.DefaultAuthenticationContext = Authenticator.Instance.Login((ILoginCredential)null);

      // The EntityManager is now "logged in", and will use this mgr.Principal
      // for all further requests to the BOS.  The Thread.CurrentPrincipal
      // has also been set.
      Console.WriteLine("Logged in user: {0}", Authenticator.Instance.DefaultAuthenticationContext.Principal.Identity.Name);
      Console.WriteLine("Thread principal after login: {0}", System.Threading.Thread.CurrentPrincipal.Identity.Name);

      // Execute a query - to see auth check in EntityServerQueryInterceptor.
      var products = mgr.Products.ToList();

      Console.WriteLine("Press ENTER to exit...");
      Console.ReadLine();
    }

  }
}
