﻿Imports IdeaBlade.EntityModel

Imports SimpleNorthwindModel
Imports IdeaBlade.EntityModel.Security

Namespace Console01

    Friend Class Program

        Shared Sub Main(ByVal args() As String)
            CType(New Program(), Program).DoIt()
        End Sub

        Private Sub DoIt()

            Dim mgr As New NorthwindManager()
            Console.WriteLine("Thread principal before login: {0}", System.Threading.Thread.CurrentPrincipal.Identity.Name)

            ' Login will null credentials.  The LoginManager will decide what to do ...
            Authenticator.Instance.DefaultAuthenticationContext = Authenticator.Instance.Login(CType(Nothing, ILoginCredential))

            ' The EntityManager is now "logged in", and will use this mgr.Principal
            ' for all further requests to the BOS.  The Thread.CurrentPrincipal
            ' has also been set.
            Console.WriteLine("Logged in user: {0}", Authenticator.Instance.DefaultAuthenticationContext.Principal.Identity.Name)
            Console.WriteLine("Thread principal after login: {0}", System.Threading.Thread.CurrentPrincipal.Identity.Name)

            ' Execute a query - to see auth check in EntityServerQueryInterceptor.
            Dim products = mgr.Products.ToList()

            Console.WriteLine("Press ENTER to exit...")
            Console.ReadLine()
        End Sub

    End Class
End Namespace
