﻿Imports IdeaBlade.EntityModel.Server

Namespace Server

  ''' <summary>
  ''' Custom implementations of EntityServerQueryInterceptor and EntityServerSaveInterceptor.
  ''' Methods in these classes will be called by DevForce (on the server) during any fetch or save.
  ''' Here we've disallowed all queries and saves except from authenticated users.
  ''' </summary>
  Public Class EntityServerQueryManager
	  Inherits EntityServerQueryInterceptor

	Protected Overrides ReadOnly Property DefaultAuthorization() As Boolean
	  Get
		Return False
	  End Get
	End Property

	Protected Overrides Function AuthorizeQuery() As Boolean
	  Return Principal.Identity.IsAuthenticated
	End Function

  End Class

  Public Class EntityServerSaveManager
	  Inherits EntityServerSaveInterceptor

	Protected Overrides ReadOnly Property DefaultAuthorization() As Boolean
	  Get
		Return False
	  End Get
	End Property

	Protected Overrides Function AuthorizeSave() As Boolean
	  Return Principal.Identity.IsAuthenticated
	End Function

  End Class

End Namespace